//+------------------------------------------------------------------+
//|                                                        Ticks.mq4 |
//|                                                       MetaQuotes |
//|                    http://www.alpari-idc.ru/ru/experts/articles/ |
//+------------------------------------------------------------------+
#property copyright "Rosh"
#property link      "http://www.alpari-idc.ru/ru/experts/articles/"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 50
#property indicator_buffers 1
#property indicator_color1 Magenta
#property indicator_width1 2

extern   int      PeriodInSec = 60;     //       
         datetime LastTradeTime = D'01.01.1980';
int      timeprev;

double ExtMapBuffer1[1];
//int myBars;
int tickCounter;
//int delimeterCounter;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init() {
   IndicatorShortName("TicksByPeriod");
   
   SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(0, ExtMapBuffer1);
   SetIndexEmptyValue(0, 0.0);
   
   SetLevelValue(0, 5);
   SetLevelValue(1,10);
   SetLevelValue(2,15);
   SetLevelValue(3,20);
   SetLevelValue(4,25);
   SetLevelValue(5,30);
   SetLevelValue(6,35);
   SetLevelValue(7,40);
   SetLevelValue(8,45);
   SetLevelValue(9,50);
   
   IndicatorDigits(0);
   
   //for (int i=Bars-1;i>=0;i--) ExtMapBuffer1[i]=0.0;
   
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit() {
   return(0);
}
  
//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void SetDelimeter() {
   string delimeterDate=TimeToStr(Time[0]);
      Print(" ");      
      int handle=WindowFind("TicksByPeriod");
      if(!ObjectCreate(delimeterDate, OBJ_VLINE, handle, Time[0], 0)) {
         Alert("      ", handle, "   ", TimeToStr(CurTime()));
         Print(" ", GetLastError(), ",   ", delimeterDate);
      }
      else {
         ObjectSet(delimeterDate,OBJPROP_COLOR,DarkGreen);
         ObjectSet(delimeterDate,OBJPROP_STYLE,STYLE_DASHDOT);
         ObjectsRedraw();
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                     |
//+------------------------------------------------------------------+
void ShiftArray() {
   int V_lines;
   string delimeterName;
   datetime firstTime;
   int BarFirstTime;
   
   ArrayCopy(ExtMapBuffer1, ExtMapBuffer1, 1, 0, ArraySize(ExtMapBuffer1)-1);
   
   V_lines=ObjectsTotal();
   for (int z=0;z<V_lines;z++) {
      delimeterName=ObjectName(z); 
      if (ObjectFind(delimeterName)!=-1) {
         if (ObjectType(delimeterName)==OBJ_VLINE) {
            firstTime = ObjectGet(delimeterName, OBJPROP_TIME1);
            BarFirstTime = iBarShift(NULL, 0, firstTime);
            firstTime = Time[BarFirstTime + 1];
            ObjectSet(delimeterName, OBJPROP_TIME1, firstTime); 
            }
         }       
      }
   return(0);
}

//+------------------------------------------------------------------+
//|                                                 |
//+------------------------------------------------------------------+
bool isNewBar()
  {
   if(TimeCurrent() - LastTradeTime > PeriodInSec) {   //       
      LastTradeTime = TimeCurrent();               //    
//Print("--- New bar ---");
      return(True);
      }
   else return(False);
  }

//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start() {
   if (timeprev != Time[0]) {
      timeprev = Time[0];
      SetDelimeter();
      ShiftArray();
   }
   
   if (isNewBar()) {
      ShiftArray();
      
      tickCounter = 1;
      ExtMapBuffer1[0] = 1;
   }
   else {
      tickCounter++;
//Print("=== 4: tik: ", tickCounter, ", sec: ", (TimeCurrent() - LastTradeTime));
      ExtMapBuffer1[0] = tickCounter;
   }
   
   return(0);
}

